package ssw.mj;

import java.io.FileReader;
import java.io.IOException;
 
/**
 * <code>Compiler</code> is the driver for the MicroJava-Compiler.
 * 
 * Execute<br>
 * <code>java ssw.mj.Compiler &lt;<i>MJ-Source-Filename</i>&gt;</code><br>
 * to start compilation.
 */
public class Compiler {

	public static void main(String[] args) {
		// --- get the filename
		if (args.length < 1) { 
			System.out.println("usage: java ssw.mj.Compiler filename.mj"); 
			return;
		}
		String filename = args[0];
		
		try {
			System.out.println("-----------------------------------");
			Scanner.init(new FileReader(filename));
			System.out.println("Parsing file " + filename + " ...\n");
			Parser.parse();
			int errCnt = Parser.Errors.count();
			switch (errCnt) {
				case  0: System.out.println("OK, no errors!"); break;
				case  1: System.out.println("\n1 error"); break;
				default: System.out.println("\n" + errCnt + " errors"); break;
			}
		} catch (IOException ioe) {
		  System.out.println("File " + filename + " not found.");
		}		
	}
}
